<?php
/*
 *	Dionys downloader (public)
 *	2016 Dionys, skiner@inbox.ru
*/

//----------------------------------------------- FUNCTIONS
function phpGetPage($url, $proxy = '')
{
	$url_parse_arr	= cut_string_ex($url, 0, '//');
	$url_proto		= $url_parse_arr[0];
	$host_arr		= cut_string_ex($url, '//', '/');
	$host			= $host_arr[0];
	$referer		= $url_proto . '//' . $host . '/';
	$context		= stream_context_create(
	array(
			'http'	=> array(
								'method' =>	'GET',
								'header' =>	'Host: ' . $host . ENT .
											'Referer: ' . $referer . ENT .
											'Accept: text/html' . ENT .
											'User-Agent: ' . 'Mozilla/5.0 (Windows NT 6.1;WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/30.0.0.0 Safari/537.36' . ENT . ENT
			)
	)
	);

	return @file_get_contents($url, false, $context);
}

function phpGetPageEx($url, $proxy = '', $post = '', $cookie = '', $hdradd = '')
{
	$cookie_opt	= empty($cookie) ? FALSE : TRUE;
	$post_opt	= empty($post) ? FALSE : TRUE;
	$post_hdr	= $post_opt ? 'POST' : 'GET';
	$postlen	= $post_opt ? strlen($post) : 0;

	$proxy_use	= false;
	$proxy_conn	= false;
	if (!empty($proxy))
	{
		$proxy_exp	= explode(':', $proxy);
		$proxy_host	= $proxy_exp[0];
		$proxy_port	= $proxy_exp[1];
		$proxy_use	= true;
		
	}

	$fp			= FALSE;

	$url_parse_arr	= cut_string_ex($url, 0, '//');
	$url_parse = $url_parse_arr[0];
	switch($url_parse)
	{
		case 'http:':
			$host_port	= '80';
			break;
		case 'https:':
			$host_port	= '443';
			break;
		default:
			$host_port	= '0';
	}
	$host_arr	= cut_string_ex($url, '//', '/');
	$host		= $host_arr[0];
	$referer	= $url_parse . '//' . $host . '/';
	$path_arr	= cut_string_ex($url, $referer, strlen($url));
	$path		= $path_arr[0];

	$str		= '';
	$headers	= '';
	$result		= 'CONNECTION ERROR';

	if ($proxy_use)
	{
		$fp = @fsockopen($proxy_host, $proxy_port);
		if ($fp)
		{
			$headers =	'CONNECT '. $host . ':' . $host_port . ' HTTP/1.0'	. ENT .
						'Connection: Close'									. ENT . ENT;

			fputs($fp, $headers);

			$str = '';

			while (!@feof($fp))
			{
				$p = fgets($fp, 1024);
				$str .= $p;
				if ($p == ENT)
				{
					break;
				}
			}

			if (!empty($str))
			{
				if (strpos($str, ' 200 ') !== FALSE)
				{
				//	print $str . ENT;
				}
				else
				{
					$result = 'PROXY CONNECTION ERROR';
					fclose($fp);
				}
			}
		}
	}
	else
	{
		$fp = @fsockopen($host, intval($host_port));
	}

	if ($fp)
	{
		$headers =		$post_hdr . ' /' . $path . ' HTTP/1.0' . ENT .
						'Host: ' . $host . ENT .
						'Referer: ' . $referer . ENT .
						'Accept: text/html' . ENT .
						'User-Agent: ' . 'Mozilla/5.0 (Windows NT 6.1;WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/30.0.0.0 Safari/537.36' . ENT;


		if ($post_opt)
		{
			$headers .=	'Content-Length: ' . $postlen . ENT;
		}
		if (strlen($hdradd) > 0)
		{
			$headers .= $hdradd . ENT;
		}
		if ($cookie_opt)
		{
			$headers .= 'Cookie: ' . $cookie . ENT;
		}

		$headers .=	 '' . ENT;
		if ($post_opt)
		{
			$headers .=	$post;
		}

		fputs($fp, $headers);

		$str = '';
		while (!@feof($fp))
		{
			$str .= @fgets($fp, 2048);
		}
		
		fclose($fp);

		$result = $str;
	}

	return $result;
}
?>